
import java.io.*;
import java.net.*;

public class URLFileCopy {
	public static void main(String[] args) throws MalformedURLException, IOException
	{
		URL url = new URL("https://byline.network/wp-content/uploads/2018/05/Dog-original-1024x683.jpg");
		
		InputStream is = url.openStream();
		
		//	입력 스트림에서 1byte 데이터를 처리 할 때 BufferedInputStream을 바로 이용
		BufferedInputStream br = new BufferedInputStream(is);
		
		FileOutputStream fos = new FileOutputStream("a.jpg");
		
		byte buf[] = new byte[2048];	//	스트림에서는 byte로 처리한다.
		
		URLConnection con = url.openConnection();
		
		//	사이즈의 크기를 알고 있어야 한다. 이 사이즈 만큼 반복문을 돌아야 한다.
		//	입력 스트림에서 출력 스트림으로의 이동에서 반복문이 필요
		int size = con.getContentLength();	//	내용의 크기
		
		System.out.println("내용의 사이즈 : " +size);
		
		int imgData = 0;
		int cnt = 0;
		
		//	읽어올 데이터가 있을 때까지 반복한다.
		//	데이터를 2048 bytes씩 가지고 온다.
		while ((imgData = br.read(buf)) != -1) 
		{
			fos.write(buf,0,imgData);
			fos.flush();
			
			cnt += imgData;
			System.out.println("File 전송률 : " +((cnt * 100)/ size) + "%");
		}
		fos.close();
		br.close();
		is.close();
	}
}

